#include <pspkernel.h>
#include <pspdisplay.h>
#include <pspdebug.h>
#include <pspgu.h>
#include <pspgum.h>
PSP_MODULE_INFO("anysqu", PSP_MODULE_USER, 1, 1);
static unsigned int __attribute__((aligned(16))) list[262144];
#define BUF_WIDTH (512)
#define SCR_WIDTH (480)
#define SCR_HEIGHT (272)

// 描画用Vertex構造体
typedef struct Vertex{
	unsigned int color;
	float x, y, z;
}Vertex;
struct Vertex* vertices;

// メインルーチン
int main() {
	pspDebugScreenInit();
	// gu設定一覧
	sceGuInit(); sceGuStart(GU_DIRECT, list); sceGuDrawBuffer(GU_PSM_8888, (void*)0, BUF_WIDTH);
	sceGuDispBuffer(SCR_WIDTH, SCR_HEIGHT, (void*)0x88000, BUF_WIDTH);
	sceGuDepthBuffer((void*)0x110000, BUF_WIDTH);
	sceGuOffset(2048 - (SCR_WIDTH/2), 2048 - (SCR_HEIGHT/2));
	sceGuViewport(2048, 2048, SCR_WIDTH, SCR_HEIGHT); sceGuScissor(0, 0, SCR_WIDTH, SCR_HEIGHT);
	sceGuEnable(GU_SCISSOR_TEST); sceGuFinish(); sceGuSync(0,0);
	sceDisplayWaitVblankStart(); sceGuDisplay(GU_TRUE);
	// ディスプレイリストからメモリ割り当て
	vertices = (struct Vertex*)sceGuGetMemory(2*5* sizeof(struct Vertex));
	unsigned long ulColor[]={0xFF000000,0xFFFF0000,0xFFFFFF00,0xFF00FF00,0xFF0000FF};
	int i=0;
	while(1){
		sceGuStart(GU_DIRECT,list); sceGuClearColor(0xFFFFFFFF); // 背景は白
		sceGuClear(GU_COLOR_BUFFER_BIT|GU_DEPTH_BUFFER_BIT);
		for(i=0;i<=4;i++){
			// スクエア用パラメータをセット。左上(50,5)-右下(85,40)範囲のハコを描画
			vertices[i*2].x = 5.0f + (float)i*30; vertices[i*2+1].x = 25.0f + (float)i*30;
			vertices[i*2].y = 5.0f; vertices[i*2+1].y = 25.0f;
			vertices[i*2].z = 0; vertices[i*2+1].z = 0;
			vertices[i*2].color = ulColor[i]; vertices[i*2+1].color = ulColor[i];
		}
		// GU_TRIANGLES、カラーはGU_COLOR_8888定義、頂点はオブジェクト数×2、構造体verticesを渡す。
		sceGuDrawArray(GU_SPRITES,GU_COLOR_8888|GU_VERTEX_32BITF|GU_TRANSFORM_2D, i*2, 0, vertices);
		// ここまで
		sceGuFinish(); sceGuSync(0,0); sceDisplayWaitVblankStart(); sceGuSwapBuffers();
	}
	return 0;
}
